#ifndef QuadDecoder_h
#define QuadDecoder_h
    
#include <Arduino.h>

#define Overflow_Size 65536    
class QuadDecoder
{
public:
QuadDecoder(unsigned int  Resolution , boolean Sens,boolean DiameterMode);

//To update value
void OverflowPlus();
void OverflowMinus();
void CounterValue(unsigned int Value);
void SetAbsolutZero();
void SetRelativeZero();
void SetZeroActiveMode();
void SwitchMode(); 
boolean RelativeModeActived(); 

float GetValue(); 

void SetResolution(unsigned int  Resolution);
void SetSens(boolean Sens);
void ToggleSens();
void SetDiameterMode (boolean DiameterMode);
void ToggleDiameterMode();


private:

void ComputeAbsoluteValue();

unsigned int _CountValue; 
long _AbsoluteCounter; 

long _AbsoluteCounterZero; 
long _RelativeCounterZero; 

unsigned int _Resolution; 
boolean _Sens; 
boolean _RelativeModeActived; 
boolean _DiameterMode; 
int _Overflow; 

};
    
#endif
