#include "RingBuffer.h"


RingBuffer::RingBuffer(const unsigned int capacity) :
  m_capacity(capacity),
  m_buffer(new byte[capacity])
{
  clear();
}
RingBuffer::~RingBuffer()
{
  delete [] m_buffer;
}
void RingBuffer::clear()
{
  m_head = m_tail = m_buffer;
  m_empty = true;
  m_full = false;
}
void RingBuffer::push(byte b)
{
  *m_tail++ = b;
  if ((unsigned int) (m_tail - m_buffer) == m_capacity) {
    m_tail = m_buffer;
  }
  m_empty = false;
  if (m_full) {
    m_head = m_tail;
  } else {
    m_full = (m_tail == m_head);
  }
}
byte RingBuffer::pop()
{
  if (m_empty) {
    return (byte) 0;
  }
  byte b = *m_head++;
  if ((unsigned int) (m_head - m_buffer) == m_capacity) {
    m_head = m_buffer;
  }
  m_full = false;
  m_empty = (m_tail == m_head);
  return b;
}
bool RingBuffer::isEmpty() const
{
  return m_empty;
}
bool RingBuffer::isFull() const
{
  return m_full;
}
