#ifndef _RING_BUFFER__H_
#define _RING_BUFFER__H_
#include <Arduino.h>
class RingBuffer
{
  private:
    unsigned int m_capacity;   
    byte*        m_buffer;     
    byte*        m_head;       
    byte*        m_tail;       
    bool         m_empty;      
    bool         m_full;       
  public:
    RingBuffer(const unsigned int capacity);
    virtual ~RingBuffer();
    void clear();
    void push(byte b);
    byte pop();
    bool isEmpty() const;
    bool isFull() const;
};

#endif
