






/*

  Chip            :   STM32F103C8T6
  freq uc         :   72Mhz
  Compiler        :   Arduino IDE 1.8.3
  Hardware config :
                       I2C_1 (SCL = PB6 and SDA = PB7) STM32 I2C
                      Quadrature X on Timer1 ( PA8 and PA9)
                      Quadrature Y on Timer3 ( PA6 and PA7)
                      Quadrature Z on Timer4 ( PA0 and PA1)
                       SW_X PB15 ------zerowanie osi X
                       SW_Y PB14-------zerowanie osi Y
                       SW_Z PB12-------zerowanie osi Z

                      

*/



#include <EEPROM.h>
#include <Wire.h>
#include <LiquidCrystal_I2C.h>
LiquidCrystal_I2C lcd(0x3F, 20, 4); // adres wyswietlacza na I2C 0x3F
#include "HardwareTimer.h"
#include "QuadDecoder.h"
#include "Button.h"
HardwareTimer timer_X(1);
HardwareTimer timer_Y(3);
HardwareTimer timer_Z(2);



QuadDecoder Quad_X(1000, false, false); //wpisać wartosc  własnego enkodera
QuadDecoder Quad_Y(1000, false, false);
QuadDecoder Quad_Z(2000, false, false);
//////////////////////////////////////////////////////////////////////////////
Button MiniDroKeyboard;
typedef struct
{
  boolean Inverted_X;
  boolean Inverted_Y;
  boolean Inverted_Z;
  boolean Diameter_Mode_Y;
  unsigned int  Reso_X;
  unsigned int  Reso_Y;
  unsigned int  Reso_Z;
} sConfigDro;
                                                               // X   Y    Z
const sConfigDro csConfigDefault = {false, false, false, false, 512, 512, 512};//wpisać wartosc  własnego enkodera



enum eMS_Dro
{
  State_Normal,
  State_In_Config
};


struct MyObject {
  float field1;
  byte field2;
  char name[10];
};


// Variable
sConfigDro ConfigDro;
eMS_Dro MS_Dro;
unsigned long TestSys;

//////////////////////////////////////////////////////////////////////////////////////

void IT_Overflow_X() {
  if (timer_X.getDirection()) {
    Quad_X.OverflowMinus();
  } else {
    Quad_X.OverflowPlus();
  }
}
void IT_Overflow_Y() {
  if (timer_Y.getDirection()) {
    Quad_Y.OverflowMinus();
  } else {
    Quad_Y.OverflowPlus();
  }
}
void IT_Overflow_Z() {
  if (timer_Z.getDirection()) {
    Quad_Z.OverflowMinus();
  } else {
    Quad_Z.OverflowPlus();
  }
}
void SysTick_Handler();

void setup()
{
  lcd.begin();
  lcd.backlight();


  MS_Dro = State_Normal;
  systick_attach_callback(SysTick_Handler);

  // Restore_Config();

  //## X  encoder ##
  pinMode(PA8, INPUT_PULLUP);  //channel A
  pinMode(PA9, INPUT_PULLUP);  //channel B
  timer_X.setMode(0, TIMER_ENCODER);
  timer_X.pause(); //stop...
  timer_X.setPrescaleFactor(1);
  timer_X.setOverflow(0xFFFF);
  timer_X.setCount(0);
  timer_X.setEdgeCounting(TIMER_SMCR_SMS_ENCODER3);
  timer_X.attachInterrupt(0, IT_Overflow_X);
  timer_X.resume();
  //timer_X.getCount();

  //## Y  encoder ##
  pinMode(PA6, INPUT_PULLUP);  //channel A
  pinMode(PA7, INPUT_PULLUP);  //channel B
  timer_Y.setMode(0, TIMER_ENCODER);
  timer_Y.pause(); //stop...
  timer_Y.setPrescaleFactor(1);
  timer_Y.setOverflow(0xFFFF);
  timer_Y.setCount(0);          //reset the counter.
  timer_Y.setEdgeCounting(TIMER_SMCR_SMS_ENCODER3);
  timer_Y.attachInterrupt(0, IT_Overflow_Y);
  timer_Y.resume();
  //timer_Y.getCount();

  //## Z   encoder ##
  pinMode(PA0, INPUT_PULLUP);  //channel A
  pinMode(PA1, INPUT_PULLUP);  //channel B
  timer_Z.setMode(0, TIMER_ENCODER);
  timer_Z.pause(); //stop...
  timer_Z.setPrescaleFactor(1);
  timer_Z.setOverflow(0xFFFF);
  timer_Z.setCount(0);          //reset the counter.
  timer_Z.setEdgeCounting(TIMER_SMCR_SMS_ENCODER3);
  timer_Z.attachInterrupt(0, IT_Overflow_Z);
  timer_Z.resume();
  // timer_Z.getCount();


  Quad_X.SetAbsolutZero();
  Quad_X.SetRelativeZero();
  Quad_Y.SetAbsolutZero();
  Quad_Y.SetRelativeZero();
  Quad_Z.SetAbsolutZero();
  Quad_Z.SetRelativeZero();



}

void loop()
{
  eButtonState eState;
  unsigned int CurrentSelection = 1;
  while (1)
  {

    Quad_X.CounterValue(timer_X.getCount());
    Quad_Y.CounterValue(timer_Y.getCount());
    Quad_Z.CounterValue(timer_Z.getCount());

    MiniDroKeyboard.Update();
    eState = MiniDroKeyboard.GiveMeTheButtonState();

    //Masterstate
    switch ( MS_Dro )
    {
      case State_Normal:

        Display_Test();
        if (eState == X_KeyShortPressed) Quad_X.SetZeroActiveMode();
        if (eState == Y_KeyShortPressed) Quad_Y.SetZeroActiveMode();
        if (eState == Z_KeyShortPressed) Quad_Z.SetZeroActiveMode();

        break;
      case State_In_Config:
        //Config mode
        if (eState == X_KeyShortPressed)
        {
          if (CurrentSelection == 1)CurrentSelection = 8;
          else CurrentSelection--;
        }
        if (eState == Z_KeyShortPressed)
        {
          if (CurrentSelection == 8)CurrentSelection = 1;
          else CurrentSelection++;
        }
        if (eState == Y_KeyShortPressed)
        {
          switch (CurrentSelection)
          {
            case 1:
              ConfigDro.Inverted_X = !ConfigDro.Inverted_X;
              break;
            case 2:
              ConfigDro.Inverted_Y = !ConfigDro.Inverted_Y;
              break;
            case 3:
              ConfigDro.Inverted_Z = !ConfigDro.Inverted_Z;
              break;
            case 4:
              ConfigDro.Diameter_Mode_Y = !ConfigDro.Diameter_Mode_Y;
              break;
            case 5:
              if (ConfigDro.Reso_X != 1)ConfigDro.Reso_X--;
              break;
              break;
            case 6:
              if (ConfigDro.Reso_Y != 1)ConfigDro.Reso_Y--;
              break;
            case 7:
              if (ConfigDro.Reso_Z != 1)ConfigDro.Reso_Z--;
              break;
            case 8:

              MS_Dro = State_Normal ;

              SaveConfigInFlash(&ConfigDro);

              Dispatch_Config(&ConfigDro);
              break;

          }
        }
        if (eState == M_KeyShortPressed)
        {
          switch (CurrentSelection)
          {
            case 1:

              break;
            case 2:

              break;
            case 3:

              break;
            case 4:
              break;
            case 5:
              if (ConfigDro.Reso_X <= 1000)ConfigDro.Reso_X++;
              break;
              break;
            case 6:
              if (ConfigDro.Reso_Y <= 1000)ConfigDro.Reso_Y++;
              break;
            case 7:
              if (ConfigDro.Reso_Z <= 1000)ConfigDro.Reso_Z++;
              break;
            case 8:
              break;

          }
        }
        Display_Config(CurrentSelection);
        break;
    }
  }
}

void Display_Test()
{
  char buffer_x[16];
  char buffer_y[16];
  char buffer_z[16];
  sprintf(buffer_x, "%8.3f", Quad_X.GetValue());
  sprintf(buffer_y, "%8.3f", Quad_Y.GetValue());
  sprintf(buffer_z, "%8.3f", Quad_Z.GetValue());

  lcd.setCursor(0, 0);
  lcd.print("Axis");
  lcd.setCursor(0, 1);
  lcd.print("X :");
  lcd.setCursor(18, 1);
  lcd.print("mm");
  lcd.setCursor(6, 1);
  lcd.print(buffer_x);

  lcd.setCursor(0, 2);
  lcd.print("Y :");
  lcd.setCursor(18, 2);
  lcd.print("mm");
  lcd.setCursor(6, 2);
  lcd.print(buffer_y);

  lcd.setCursor(0, 3);
  lcd.print("Z :");
  lcd.setCursor(18, 3);
  lcd.print("mm");
  lcd.setCursor(6, 3);
  lcd.print(buffer_z);



}
void Display_Config(unsigned int CurrentSelection)
{

}
void Restore_Config()
{
  //Read Config in Memory
  ReadConfigInFlash(&ConfigDro);
  //Dispatch the config
  Dispatch_Config(&ConfigDro);

}
void SaveConfigInFlash(sConfigDro *pConf)
{
  unsigned int uiCount;
  char *pt;
  EEPROM.format();
  pt = (char*)pConf;
  for (uiCount = 0; uiCount < sizeof(sConfigDro); uiCount++)
  {
    EEPROM.write(uiCount, *pt);
    pt++;
  }
}
void ReadConfigInFlash(sConfigDro *pConf)
{
  unsigned int uiCount;
  uint16 uiState;
  uint16 value;
  char *pt;
  uiState = EEPROM_OK;
  pt = (char*)pConf;
  for (uiCount = 0; uiCount < sizeof(sConfigDro); uiCount++)
  {
    uiState |= EEPROM.read(uiCount, &value);
    *pt = (char) value;
    pt++;
  }
  if (uiState != EEPROM_OK)
  {
    //Problem, restore default
    *pConf = csConfigDefault;
  }
}


void Dispatch_Config(sConfigDro *pConf)
{
  Quad_X.SetSens( pConf->Inverted_X );
  Quad_Y.SetSens( pConf->Inverted_Y );
  Quad_Z.SetSens( pConf->Inverted_Z );
  Quad_Y.SetDiameterMode(pConf->Diameter_Mode_Y);
  Quad_X.SetResolution(pConf->Reso_X);
  Quad_Y.SetResolution(pConf->Reso_Y);
  Quad_Z.SetResolution(pConf->Reso_Z);
}
